<?php

# PHP-Web-Statistik Version 1.4
# Copyright (c) 2005 - Reimar Hoven
#
# This file is part of PHP-Web-Statistik.
#
# PHP-Web-Statistik is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# PHP-Web-Statistik is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with PHP-Web-Statistik; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# License: GNU GPL (GNU General Public License. See COPYING file)
# Version : 1.4 Release date: January 2005
# PHP-Web-Statistik official web site and latest version: http://www.php-web-statistik.de

### browser detection ###

function browser_detection ( $var , $var2)

{
    if (preg_match("/windows nt 5.1/i",$var)) $temp = 'Windows XP';
    elseif (preg_match("/windows xp/i",$var)) $temp = 'Windows XP';
    elseif (preg_match("/linux/i",$var)) $temp = 'Linux';
    elseif (preg_match("/macintosh/i",$var)) $temp = 'Macintosh';
    elseif (preg_match("/win 9x 4.90/i",$var)) $temp = 'Windows Me';
    elseif (preg_match("/windows me/i",$var)) $temp = 'Windows Me';
    elseif (preg_match("/windows nt 5.0/i",$var)) $temp = 'Windows 2000';
    elseif (preg_match("/windows 2000/i",$var)) $temp = 'Windows 2000';
    elseif (preg_match("/windows nt 3.1/i",$var)) $temp = 'Windows 3.1';
    elseif (preg_match("/windows nt 3.5.0/i",$var)) $temp = 'Windows NT 3.5';
    elseif (preg_match("/windows nt 3.5.1/i",$var)) $temp = 'Windows NT 3.5.1';
    elseif (preg_match("/windows nt 4.0/i",$var)) $temp = 'Windows NT 4.0';
    elseif (preg_match("/windows 98/i",$var)) $temp = 'Windows 98';
    elseif (preg_match("/windows 95/i",$var)) $temp = 'Windows 95';
    elseif (preg_match("/sunos/i",$var)) $temp = 'SunOS';
    else $temp = $var2;

    return $temp;
}

###############################

### operating system detection ###

function os_detection ( $var , $var2)

{
    if (preg_match("/Opera/i",$var)) $temp = 'Opera';
    elseif (preg_match("/MSIE 6/i",$var)) $temp = 'Internet Explorer 6';
    elseif (preg_match("/MSIE 5.5/i",$var)) $temp = 'Internet Explorer 5.5';
    elseif (preg_match("/MSIE 5.0/i",$var)) $temp = 'Internet Explorer 5';
    elseif (preg_match("/MSIE 4/i",$var)) $temp = 'Internet Explorer 4';
    elseif (preg_match("/Netscape\/7.0/i",$var)) $temp = 'Netscape 7';
    elseif (preg_match("/Mozilla\/5.0/i",$var)) $temp = 'Netscape 6';
    elseif (preg_match("/Mozilla\/4.7/i",$var)) $temp = 'Netscape 4.7';
    elseif (preg_match("/Mozilla\/4.6/i",$var)) $temp = 'Netscape 4.6';
    elseif (preg_match("/Mozilla\/4.5/i",$var)) $temp = 'Netscape 4.5';
    elseif (preg_match("/rv:1.4/i",$var)) $temp = 'Mozilla 1.4';
    elseif (preg_match("/rv:1.5a/i",$var)) $temp = 'Mozilla 1.5a';
    elseif (preg_match("/rv:1.5/i",$var)) $temp = 'Mozilla 1.5';
    elseif (preg_match("/Galeon/i",$var)) $temp = 'Galeon';
    elseif (preg_match("/Konqueror/i",$var)) $temp = 'Konqueror';
    else $temp = $var2;

    return $temp;
}
###############################

### function display chart ######################################################

function prozent($howmuch)
{

 echo "<img src='chart.gif' border=0 height='12' width='".($howmuch*2)."'>";

}

#########################################################################


### funktion statistik ##################################################

 function statistik_display ( $statistik_name , $statistik_db , $order , $width_key , $count_elements )

  {

     ### order machen ###############################

    if ( $order == "ksort" )
     ksort ( $statistik_db );

    if ( $order == "krsort" )
     krsort ( $statistik_db );

    if ( $order == "arsort" )
     arsort ( $statistik_db );

    if ( $order == "asort" )
     asort ( $statistik_db );

    if ( $order == "rsort" )
     rsort ( $statistik_db );

    #### display des titels ###############################

     echo "<br>  <br>";
     echo "<table border='0' align='center' rules='none'>";
     echo "<tr><td><H1>".$statistik_name." (".count($statistik_db).")</H1></td></tr></table>";
     echo "<table border='1' align='center' rules='none'>";

    ### einzel eintrge ausgeben ##########################

    $elements = 0;


     foreach ( $statistik_db as $var )

      {

        ##########

           if ( $elements < $count_elements )

               {

                 echo "<th><th align='left' width=".$width_key.">";
                 echo key ( $statistik_db );
                 echo "</th>";

                 echo "<td width='203' bgcolor='#000000'>";
                 echo prozent( ( int )round ( $var/array_sum($statistik_db)*100 ) );
                 echo "</td>";

                 echo "<td width='50' align='right'>";
                 echo ( int ) round ( $var/array_sum($statistik_db)*100 )." %";
                 echo "</td>";

                 echo "<th width='50' align='right'>";
                 echo $var;
                 echo "</th></tr>";

                }

        #########


        $elements++;

         # nexten Eintrag im Array anstarten
         next($statistik_db);

       }

 echo "</table>";

  }

#########################################################################

### variables ##############################################################################

$database_files  = array ();
$hour            = array ();
$day             = array ();
$weekday         = array ();
$month           = array ();
$year            = array ();
$hostname_kurz   = array ();
$browser         = array ();
$browser_long    = array ();
$os              = array ();
$os_long         = array ();
$siteorder       = array ();
$siteorder_array = array ();
$last_time       = array ();
$last_hostname   = array ();
$last_browser    = array ();
$last_site       = array ();
$last_referer    = array ();
$last_counter    = 0;
$referer         = array ();
$site            = array ();
$domain          = array ();
$first_visitor_counter = 0;
$daysago         = array ();
$referer_daysago = array ();
$allarray        = array ();
$ip_allarray     = array ();
$sort_hlp_db     = array ();
$search_words    = array ();
$search_engines  = array ();
$color_depth     = array ();
$resolution      = array ();

$temp = 0;

### Country Array ######################

$country_array = array (
 "ac"=>"Ascension Island ", "ad"=>"Andorra ", "ae"=>"United Arab Emirates ", "af"=>"Afghanistan ", "ag"=>"Antigua and Barbuda ",
 "ai"=>"Anguilla ", "al"=>"Albania ", "am"=>"Armenia ", "an"=>"Netherlands Antilles ", "ao"=>"Angola ", "aq"=>"Antarctica ",
 "ar"=>"Argentina ", "as"=>"American Samoa ", "at"=>"Austria ", "au"=>"Australia ", "aw"=>"Aruba ", "az"=>"Azerbaijan ",
 "ba"=>"Bosnia and Herzegovina ", "bb"=>"Barbados ", "bd"=>"Bangladesh ", "be"=>"Belgium ", "bf"=>"Burkina Faso ",
 "bg"=>"Bulgaria ", "bh"=>"Bahrain ", "bi"=>"Burundi ", "bj"=>"Benin ", "bm"=>"Bermuda ", "bn"=>"Brunei Darussalam ",
 "bo"=>"Bolivia ", "br"=>"Brazil ", "bs"=>"Bahamas ", "bt"=>"Bhutan ", "bv"=>"Bouvet Island ", "bw"=>"Botswana ",
 "by"=>"Belarus ", "bz"=>"Belize ", "ca"=>"Canada ", "cc"=>"Cocos (Keeling) Islands ","cd"=>"Congo, Democratic Republic of the ",
 "cf"=>"Central African Republic ", "cg"=>"Congo, Republic of ", "ch"=>"Switzerland ", "ci"=>"Cote d'Ivoire ",
 "ck"=>"Cook Islands ", "cl"=>"Chile ", "cm"=>"Cameroon ", "cn"=>"China ", "co"=>"Colombia ", "cr"=>"Costa Rica ",
 "cu"=>"Cuba ", "cv"=>"Cap Verde ", "cx"=>"Christmas Island ", "cy"=>"Cyprus ", "cz"=>"Czech Republic ","de"=>"Germany ",
 "dj"=>"Djibouti ", "dk"=>"Denmark ", "dm"=>"Dominica ", "do"=>"Dominican Republic ", "dz"=>"Algeria ", "ec"=>"Ecuador ",
 "ee"=>"Estonia ", "eg"=>"Egypt ", "eh"=>"Western Sahara ", "er"=>"Eritrea ", "es"=>"Spain ", "et"=>"Ethiopia ", "fi"=>"Finland ",
 "fj"=>"Fiji ", "fk"=>"Falkland Islands (Malvina) ", "fm"=>"Micronesia, Federal State of ", "fo"=>"Faroe Islands ",
 "fr"=>"France ", "ga"=>"Gabon ", "gd"=>"Grenada ", "ge"=>"Georgia ", "gf"=>"French Guiana ", "gg"=>"Guernsey ",
 "gh"=>"Ghana ", "gi"=>"Gibraltar ", "gl"=>"Greenland ", "gm"=>"Gambia ", "gn"=>"Guinea ", "gp"=>"Guadeloupe ",
 "gq"=>"Equatorial Guinea ", "gr"=>"Greece ", "gs"=>"South Georgia and the South Sandwich Islands ", "gt"=>"Guatemala ",
 "gu"=>"Guam ", "gw"=>"Guinea Bissau ", "gy"=>"Guyana ", "hk"=>"Hong Kong ", "hm"=>"Heard and McDonald Islands ",
 "hn"=>"Honduras ", "hr"=>"Croatia/Hrvatska ", "ht"=>"Haiti ", "hu"=>"Hungary ", "id"=>"Indonesia ", "ie"=>"Ireland ",
 "il"=>"Israel ", "im"=>"Isle of Man ", "in"=>"India ", "io"=>"British Indian Ocean Territory ", "iq"=>"Iraq ",
 "ir"=>"Iran (Islamic Republic of) ", "is"=>"Iceland ", "it"=>"Italy ", "je"=>"Jersey ", "jm"=>"Jamaica ", "jo"=>"Jordan ",
 "jp"=>"Japan ", "ke"=>"Kenya ", "kg"=>"Kyrgyzstan ", "kh"=>"Cambodia ", "ki"=>"Kiribati ", "km"=>"Comoros ",
"kn"=>"Saint Kitts and Nevis ", "kp"=>"Korea, Democratic People's Republic ", "kr"=>"Korea, Republic of ",
"kw"=>"Kuwait ",   "ky"=>"Cayman Islands ", "kz"=>"Kazakhstan ", "la"=>"Lao People's Democratic Republic ", "lb"=>"Lebanon ", "lc"=>"Saint Lucia ",
"li"=>"Liechtenstein ", "lk"=>"Sri Lanka ", "lr"=>"Liberia ", "ls"=>"Lesotho ", "lt"=>"Lithuania ", "lu"=>"Luxembourg ",
"lv"=>"Latvia ", "ly"=>"Libyan Arab Jamahiriya ", "ma"=>"Morocco ", "mc"=>"Monaco ", "md"=>"Moldova, Republic of ", "mg"=>"Madagascar ",
"mh"=>"Marshall Islands ", "mk"=>"Macedonia, Former Yugoslav Republic ",  "ml"=>"Mali ",
"mm"=>"Myanmar ", "mn"=>"Mongolia ", "mo"=>"Macau ", "mp"=>"Northern Mariana Islands ", "mq"=>"Martinique ", "mr"=>"Mauritania ",
"ms"=>"Montserrat ", "mt"=>"Malta ", "mu"=>"Mauritius ", "mv"=>"Maldives ", "mw"=>"Malawi ", "mx"=>"Mexico ",
"my"=>"Malaysia ", "mz"=>"Mozambique ", "na"=>"Namibia ", "nc"=>"New Caledonia ", "ne"=>"Niger ",  "nf"=>"Norfolk Island ",
"ng"=>"Nigeria ", "ni"=>"Nicaragua ", "nl"=>"Netherlands ", "no"=>"Norway ", "np"=>"Nepal ", "nr"=>"Nauru ",
"nu"=>"Niue ", "nz"=>"New Zealand ", "om"=>"Oman ", "pa"=>"Panama ", "pe"=>"Peru ",  "pf"=>"French Polynesia ",
"pg"=>"Papua New Guinea ", "ph"=>"Philippines ", "pk"=>"Pakistan ", "pl"=>"Poland ",  "pm"=>"St Pierre and Miquelon ", "pn"=>"Pitcairn Island ",
"pr"=>"Puerto Rico ", "ps"=>"Palestinian Territories ", "pt"=>"Portugal ", "pw"=>"Palau ", "py"=>"Paraguay ", "qa"=>"Qatar ",
"re"=>"Reunion Island ", "ro"=>"Romania ",  "ru"=>"Russian Federation ", "rw"=>"Rwanda ", "sa"=>"Saudi Arabia ",  "sb"=>"Solomon Islands ",
"sc"=>"Seychelles ", "sd"=>"Sudan ", "se"=>"Sweden ", "sg"=>"Singapore ", "sh"=>"St Helena ", "si"=>"Slovenia ",
"sj"=>"Svalbard and Jan Mayen Islands ", "sk"=>"Slovak Republic ",  "sl"=>"Sierra Leone ", "sm"=>"San Marino ", "sn"=>"Senegal ",    "so"=>"Somalia ",
"sr"=>"Suriname ", "st"=>"Sao Tome and Principe ", "sv"=>"El Salvador ", "sy"=>"Syrian Arab Republic ", "sz"=>"Swaziland ", "tc"=>"Turks and Caicos Islands ",
"td"=>"Chad ", "tf"=>"French Southern Territories ", "tg"=>"Togo ", "th"=>"Thailand ", "tj"=>"Tajikistan ", "tk"=>"Tokelau ",
"tm"=>"Turkmenistan ", "tn"=>"Tunisia ", "to"=>"Tonga ", "tp"=>"East Timor ", "tr"=>"Turkey ", "tt"=>"Trinidad and Tobago ",
"tv"=>"Tuvalu ", "tw"=>"Taiwan ", "tz"=>"Tanzania ", "ua"=>"Ukraine ", "ug"=>"Uganda ", "uk"=>"United Kingdom ",
"um"=>"US Minor Outlying Islands ", "us"=>"United States ", "uy"=>"Uruguay ", "uz"=>"Uzbekistan ", "va"=>"Holy See (City Vatican State) ", "vc"=>"Saint Vincent and the Grenadines ",
"ve"=>"Venezuela ", "vg"=>"Virgin Islands (British) ", "vi"=>"Virgin Islands (USA) ", "vn"=>"Vietnam ", "vu"=>"Vanuatu ",  "wf"=>"Wallis and Futuna Islands ",
"ws"=>"Western Samoa ", "ye"=>"Yemen ", "yt"=>"Mayotte ", "yu"=>"Yugoslavia ", "za"=>"South Africa ", "zm"=>"Zambia ",
"zw"=>"Zimbabwe ", "aero"=>"Aviation (.aero)", "biz"=>"Business (.biz)", "coop"=>"Co-Operative Orga. (.coop)", "info"=>"Info (.info)",
"int"=>"Intern.Organisation (.int)", "name"=>"Homepage (.name)", "us"=>"Museum (.museum)", "us"=>"USA (.us)",
"org"=>"Organisation (.org)", "com"=>"Commercial (.com)", "net"=>"Network (.net)", "org"=>"Organisation (.org)",
"edu"=>"University USA (.edu)", "gov"=>"Government USA (.gov)", "mil"=>"US Army (.mil)"

   );

### read out stat.cfg ######################################################################

 $datei = fopen( "stat.cfg" , "r" );

  while ( !FEOF ( $datei ) )
     {
       $data_array_stat = fgetcsv ( $datei , 4096 , "=" );

       if ( ( isset ( $data_array_stat[0] ) ) && ( !empty ( $data_array_stat[0] ) ) )
        $$data_array_stat[0] = $data_array_stat [1];

     }

fclose ( $datei );

unset ( $datei );

#########################################################
echo "<html><head><title>php-web-statistik v1.4 - ".$exceptiondomain."</title><link rel='stylesheet' type='text/css' href='stat.css'></head><body>";
#########################################################

############################################################################################

    $datei = fopen( $directory , "r" );

      while ( !FEOF ( $datei ) )
       {
         $data_array_database = fgetcsv ( $datei , 4096 , "*" );

         ### put last hits in array ###

            $last_time     [ $last_counter ] = $data_array_database [0];
            $last_hostname [ $last_counter ] = $data_array_database [2];
            $last_browser  [ $last_counter ] = $data_array_database [3];
            $last_site     [ $last_counter ] = $data_array_database [4];
            $last_referer  [ $last_counter ] = $data_array_database [5];

            $last_counter++;


         ### get first visitor ###

         if ( $first_visitor_counter == 0 )
              {
                $first_visitor=$data_array_database[0];
                $first_visitor_counter=1;
              }

           ### put day in array ####

                $wochentage = array (
                  "Monday"=>$weekday1,
                  "Tuesday"=>$weekday2,
                  "Wednesday"=>$weekday3,
                  "Thursday"=>$weekday4,
                  "Friday"=>$weekday5,
                  "Saturday"=>$weekday6,
                  "Sunday"=>$weekday7
                 );

           $wochentag = date ( "l" , $data_array_database[0] );

           if ( array_key_exists ( $wochentag , $wochentage ) )
                     $wochentag = $wochentage [ $wochentag ];

           $domain_temp        = explode ( "." , $data_array_database[2] );
           $hostname_temp      = $domain_temp;                      
           $resolution_temp    = $data_array_database[6];
           $color_depth_temp   = $data_array_database[7];
           $domain_temp        = strtolower ( $domain_temp [ count( $domain_temp )-1 ] );

           if ( array_key_exists ( $domain_temp, $country_array ) )
            {
             $domain_temp   = $country_array [ $domain_temp ];
             $hostname_temp = strtolower ( $hostname_temp [ count( $hostname_temp )-2 ].".".$hostname_temp [ count( $hostname_temp )-1] );
            }
           else
            {
             $domain_temp   = $unknown;
             $hostname_temp = $unknown;
            }

            $os_temp      = browser_detection ( $data_array_database[3] , $unknown );
            $browser_temp = os_detection ( $data_array_database[3] , $unknown );

          if ( ( array_key_exists ( date( "dHmY" , $data_array_database[0] ) , $allarray ) ) && ( array_key_exists ( $data_array_database[1] , $ip_allarray ) ) )
           $temp = 0;
          else
           {

            if  ( array_key_exists ( date( $date_format , $data_array_database[0] ) , $daysago ) )
              {

               if ( $data_array_database[0] > ( date ( "U" , mktime ( 0,0,0, date ( "m" ) -1 , date ( "d" ) , date ( "Y" ) ) ) ) )
                {
                  $daysago [ date( $date_format , $data_array_database[0] ) ] = $daysago [ date( $date_format , $data_array_database[0] ) ] + 1;

                   if ( !empty ( $data_array_database [ 5 ] ) && ( substr ( $data_array_database [ 5 ], 0 , strlen ( $exceptiondomain ) ) != $exceptiondomain ) )
                    {

                     if ( strlen ( $data_array_database [ 5 ] ) > 90 )
                      $referer_temp = substr ( $data_array_database [ 5 ] , 0 , 90 );
                     else
                      $referer_temp = $data_array_database [ 5 ];

                      if ( array_key_exists ( $referer_temp, $referer_daysago ) )
                       $referer_daysago [ $referer_temp ] = $referer_daysago [ $referer_temp ] + 1;
                    }
                }

              }
            else
              {
                if ( $data_array_database[0] > ( date ( "U" , mktime ( 0,0,0, date ( "m" ) -1 , date ( "d" ) , date ( "Y" ) ) ) ) )
                 {

                  $daysago [ date( $date_format , $data_array_database[0] ) ] = 1;

                     if ( !empty ( $data_array_database [ 5 ] ) && ( substr ( $data_array_database [ 5 ], 0 , strlen ( $exceptiondomain ) ) != $exceptiondomain ) )
                     {

                      if ( strlen ( $data_array_database [ 5 ] ) > 90 )
                        $referer_temp = substr ( $data_array_database [ 5 ] , 0 , 90 );
                       else
                        $referer_temp = $data_array_database [ 5 ];

                      $referer_daysago [ $referer_temp ] = 1;
                     }
                 }
              }

             if  ( array_key_exists ( date( "H." , $data_array_database[0] ) , $hour ) )
              $hour [ date( "H." , $data_array_database[0] ) ] = $hour [ date( "H." , $data_array_database[0] ) ] + 1;
             else
              $hour [ date( "H." , $data_array_database[0] ) ] = 1;


             if  ( array_key_exists ( date( "m/Y" , $data_array_database[0] ) , $month ) )
              $month [ date( "m/Y" , $data_array_database[0] ) ] = $month [ date( "m/Y" , $data_array_database[0] ) ] + 1;
             else
              $month [ date( "m/Y" , $data_array_database[0] ) ] = 1;


             if  ( array_key_exists ( date( "Y" , $data_array_database[0] ) , $year ) )
              $year [ date( "Y" , $data_array_database[0] ) ] = $year [ date( "Y" , $data_array_database[0] ) ] + 1;
             else
              $year [ date( "Y" , $data_array_database[0] ) ] = 1;


             if  ( array_key_exists ( $wochentag , $weekday ) )
              $weekday [ $wochentag ] = $weekday [ $wochentag ] + 1;
             else
              $weekday [ $wochentag ] = 1;

             if ( array_key_exists ( $browser_temp , $browser ) )
              $browser [ $browser_temp ] = $browser [ $browser_temp ] + 1;
             else
              $browser [ $browser_temp ] = 1;

             if ( array_key_exists ( $os_temp , $os ) )
              $os [ $os_temp ] = $os [ $os_temp ] + 1;
             else
              $os [ $os_temp ] = 1;

             if ( array_key_exists ( $domain_temp , $domain ) )
              $domain [ $domain_temp ] = $domain [ $domain_temp ] + 1;
             else
              $domain [ $domain_temp ] = 1;
              
             if ( array_key_exists ( $color_depth_temp , $color_depth ) )
              $color_depth [ $color_depth_temp ] = $color_depth [ $color_depth_temp ] + 1;
             else
              $color_depth [ $color_depth_temp ] = 1;            

             if ( array_key_exists ( $resolution_temp , $resolution ) )
              $resolution [ $resolution_temp ] = $resolution [ $resolution_temp ] + 1;
             else
              $resolution [ $resolution_temp ] = 1;            

             if  ( array_key_exists ( date( "d." , $data_array_database[0] ) , $day ) )
              $day [ date( "d." , $data_array_database[0] ) ] = $day [ date( "d." , $data_array_database[0] ) ] + 1;
             else
              $day [ date( "d." , $data_array_database[0] ) ] = 1;

             if ( array_key_exists ( $hostname_temp , $hostname_kurz ) )
              $hostname_kurz [ $hostname_temp ] = $hostname_kurz [ $hostname_temp ] + 1;
             else
              $hostname_kurz [ $hostname_temp ] = 1;

             if ( array_key_exists ( $data_array_database [ 1 ] , $siteorder ) )
              {
                if ( substr ( strrchr ( $siteorder [ $data_array_database [ 1 ] ] , "+" ) , 1 ) == $data_array_database [ 4 ] )
                 { }
                else
                 $siteorder [ $data_array_database [ 1 ] ] = $siteorder [ $data_array_database [ 1 ] ]."+".$data_array_database [ 4 ];
              }
             else
              {
               $siteorder [ $data_array_database [ 1 ] ] = $data_array_database [ 4 ];
              }

            $ip_allarray [ $data_array_database[1] ] = 1;
            $temper = date( "dHmY" , $data_array_database[0] );
            $allarray [ $temper ] = 1;

           }

           ### put site in array ####################

              $site_temp = $data_array_database [ 4 ];

              if ( array_key_exists ( $site_temp, $site ) )
               $site [ $site_temp ] = $site [ $site_temp ] + 1;
              else
               $site [ $site_temp ] = 1;


           ### Referer ####################

  if ( !empty ( $data_array_database [ 5 ] ) && ( substr ( $data_array_database [ 5 ], 0 , strlen ( $exceptiondomain ) ) != $exceptiondomain ) )
            {
              $referer_temp = $data_array_database [ 5 ];

                parse_str ( str_replace ( "?","&","___url_http_referer=".$referer_temp ) , $vars );

                $searchengine = "";

                $altterms = "";
                
                ###################################################### von tgo eingefgt
                if ( !array_key_exists ( "su" , $vars) )
                 $vars [ "su" ] = "";
                ########################################################################                

                if ( !array_key_exists ( "q" , $vars) )
                 $vars [ "q" ] = "";
                if ( !array_key_exists ( "p" , $vars) )
                 $vars [ "p" ] = "";
                if ( !array_key_exists ( "query" , $vars) )
                 $vars [ "query" ] = "";
                if ( !array_key_exists ( "search" , $vars) )
                 $vars [ "search" ] = "";
                if ( !array_key_exists ( "Keywords" , $vars) )
                 $vars [ "Keywords" ] = "";
                if ( !array_key_exists ( "ask" , $vars) )
                 $vars [ "ask" ] = "";
                if ( !array_key_exists ( "qkw" , $vars) )
                 $vars [ "qkw" ] = "";
                if ( !array_key_exists ( "searchfor" , $vars) )
                 $vars [ "searchfor" ] = "";
                if ( !array_key_exists ( "terms" , $vars) )
                 $vars [ "terms" ] = "";

                if ( preg_match ("/http.+google\..+\/.+/",$vars["___url_http_referer"] ) )
                 { $searchengine = "Google"; $terms = $vars [ "q" ]; }

                if ( preg_match ("/http.+altavista\..+\/.+/",$vars["___url_http_referer"] ) )
                 { $searchengine = "Altavista"; $terms = $vars["q"]; }

                if ( preg_match ("/http.+wisenut\..+\/.+/",$vars["___url_http_referer"] ) )
                 { $searchengine = "WiseNet"; $terms = $vars["q"];   }

                if ( preg_match ("/http.+alltheweb\..+\/.+/",$vars["___url_http_referer"]) )
                 { $searchengine = "AllTheWeb"; $terms = $vars["q"]; }

                if ( preg_match ("/http.+\.yahoo\..+\/.+/",$vars["___url_http_referer"] ) )
                 { $searchengine = "Yahoo"; $terms = $vars["p"]; }

                if ( preg_match ("/http.+\.aol\..+\/.+/",$vars["___url_http_referer"]) )
                 { $searchengine = "AOL"; $terms = $vars["query"]; }

                if ( preg_match ("/http.+netscape\..+\/.+/",$vars["___url_http_referer"]) )
                 { $searchengine = "Netscape"; $terms = $vars["query"]; }

                if ( preg_match ("/http.+\.lycos\..+\/.+/",$vars["___url_http_referer"]) )
                 { $searchengine = "Lycos"; $terms = $vars["query"]; }

                if ( preg_match ("/http.+\.teoma\..+\/.+/",$vars["___url_http_referer"]) )
                 { $searchengine = "Teoma"; $terms = $vars["query"]; }

                if ( preg_match ("/http.+\.dmoz\..+\/.+/",$vars["___url_http_referer"]) )
                 { $searchengine = "dmoz"; $terms = $vars["search"]; }

                if ( preg_match ("/http.+\.overture\..+\/.+/",$vars["___url_http_referer"]) )
                 { $searchengine = "Overture"; $terms = $vars["Keywords"]; }

                if ( preg_match ("/http.+\.ask\..+\/.+/",$vars["___url_http_referer"]) )
                 { $searchengine = "AskJeeves"; $terms = $vars["ask"]; }

                if ( preg_match ("/http.+\.about\..+\/.+/",$vars["___url_http_referer"]) )
                 { $searchengine = "About"; $terms = $vars["terms"]; }

                if ( preg_match ("/http.+\.looksmart\..+\/.+/",$vars["___url_http_referer"]) )
                 { $searchengine = "LookSmart"; $terms = $vars["key"]; }

                if ( preg_match ("/http.+\.excite\..+\/.+/",$vars["___url_http_referer"]) )
                 { $searchengine = "Excite"; $terms = $vars["qkw"]; }

                if ( preg_match ("/http.+\.iwon\.com.+\/.+/",$vars["___url_http_referer"]) )
                 { $searchengine = "IWon"; $terms = $vars["searchfor"]; }

                if ( preg_match ("/http.+\.webcrawler\.com.+\/.+/",$vars["___url_http_referer"]) )
                 { $searchengine = "WebCrawler"; $terms = $vars["qkw"]; }

                if ( preg_match("/http.+\.msn\..+\/.+/",$vars["___url_http_referer"]) )
                 { $searchengine = "MSN"; $terms = $vars["q"]; $altterms = $vars["origq"]; }
                 
                ############################################################################ von tgo eingefgt

                if ( preg_match ("/http.+fireball\..+\/.+/",$vars["___url_http_referer"] ) )
                 { $searchengine = "FireBall"; $terms = $vars [ "query" ]; }

                if ( preg_match ("/http.+web\..+\/.+/",$vars["___url_http_referer"] ) )
                 { $searchengine = "WEB.de"; $terms = $vars [ "su" ]; }

                if ( preg_match ("/http.+216.239.59\..+\/.+/",$vars["___url_http_referer"] ) )
                 { $searchengine = "GoogleIP"; $terms = $vars [ "q" ]; }
                 
                ###############################################################################################

                if ( $searchengine )
                 {
                   $message = $searchengine;
                   $termarray=preg_split("/ /",$terms);

                   $search_words_temp = "[";

                   while ( list ( $key , $value ) = each ( $termarray ) )
                   {
                     $message.= " [".$value."]";
                     $search_words_temp.= $value." ";
                   }

                    if( $altterms )
                     {
                       $termarray = preg_split("/ /",$altterms );

                       while ( list  ($key , $value) = each ( $termarray ) )
                        {
                          $message.= " [".$value."]";
                          $search_words_temp.= $value." ";
                        }

                     }

                  $search_words_temp.= "]";

                }
               else
                {

                 $message = $data_array_database [ 5 ];

                   if ( ( strpos ( $message , "216.239.37.104" ) > -1 ) ||
                      ( strpos ( $message , "216.239.39.104" ) > -1 ) )
                       $message = "google translator";

                   if ( strpos ( $message , "topsitelists.com" ) > -1 )
                    $message = "topsitelists.com";

                   if ( strlen ( $message ) > 90 )
                    $message = substr ( $message , 0 , 90 );

                }

             if ( ( !empty ( $searchengine ) ) && ( $searchengine != "" ) )
              {
                if ( array_key_exists ( $searchengine , $search_engines ) )
                 $search_engines [ $searchengine ] = $search_engines [ $searchengine ] + 1;
                else
                 $search_engines [ $searchengine ] = 1;

                if ( array_key_exists ( $search_words_temp , $search_words ) )
                 $search_words [ $search_words_temp ] = $search_words [ $search_words_temp ] + 1;
                else
                 $search_words [ $search_words_temp ] = 1;

              }

              if ( array_key_exists ( $message , $referer ) )
               $referer [ $message ] = $referer [ $message ] + 1;
              else
               $referer [ $message ] = 1;

          }
       }

    fclose ( $datei );

### sort weekdays (thanks to www.hoergeraet.de.vu) ###

 if ( !array_key_exists ( $weekday1 , $weekday ) )
  $weekday [ $weekday1 ] = 0;
 if ( !array_key_exists ( $weekday2 , $weekday ) )
  $weekday [ $weekday2 ] = 0;
 if ( !array_key_exists ( $weekday3 , $weekday ) )
  $weekday [ $weekday3 ] = 0;
 if ( !array_key_exists ( $weekday4 , $weekday ) )
  $weekday [ $weekday4 ] = 0;
 if ( !array_key_exists ( $weekday5 , $weekday ) )
  $weekday [ $weekday5 ] = 0;
 if ( !array_key_exists ( $weekday6 , $weekday ) )
  $weekday [ $weekday6 ] = 0;
 if ( !array_key_exists ( $weekday7 , $weekday ) )
  $weekday [ $weekday7 ] = 0;

 $sort_hlp_db = array ( $weekday1 => $weekday [ $weekday1 ],
                        $weekday2 => $weekday [ $weekday2 ],
                        $weekday3 => $weekday [ $weekday3 ],
                        $weekday4 => $weekday [ $weekday4 ],
                        $weekday5 => $weekday [ $weekday5 ],
                        $weekday6 => $weekday [ $weekday6 ],
                        $weekday7 => $weekday [ $weekday7 ]
                       );

  $weekday = $sort_hlp_db;

#####################

echo "<center><table width='618' height='10' border='0' cellspacing='0' cellpadding='0' marginwidth='0' marginheight='0'>";
echo "<tr><td></td><td><center><b>".array_sum($year)."</b> ".$display." ".date($date_format,$first_visitor)." ".date($time_format,$first_visitor)."<br>".$exceptiondomain."</center></td></tr></table></center>";


if ( $enabled == "yes" )
 {
 echo "<br>";
 echo "<table border='0' align='center' >";
 echo "<font size='2'></font>";

 ##### form field for lasthits ###
 
 if ( isset ( $lastnumber ) && !empty ( $lastnumber ) ) 
  $lasthits = $lastnumber;
 
 #################################

 echo "<tr><td><big>".$lasthits_name1." ".$lasthits." ".$lasthits_name2."</big></td></tr></table>";

 echo "<table border='1' align='center' >";
 echo "<tr>";
 echo" <td align='left' width='25'><B><font size='2'>nr.</font></B></td>";

 echo" <td align='center' width='120'><B><font size='2'>".$short_timestamp."</font></B></td>";
 echo" <td align='center' width='260'><B><font size='2'>".$short_hostname."</font></B></td>";
 echo" <td align='center' width='150'><B><font size='2'>".$short_browser."</font></B></td>";
 echo" <td align='center' width='120'><B><font size='2'>".$short_os."</font></B></td>";
 echo" <td align='center' width='120'><B><font size='2'>".$short_site."</font></B></td>";
 echo" <td align='center' width='100'><B><font size='2'>".$short_referer."</font></B></td>";
 

 echo "</tr>";

$i = ( count ( $last_time ) -1 ) - $lasthits;

for ( $i ; $i < ( count ( $last_time ) -1 ) ; $i++ )
 {

   if ( !empty ( $last_browser[$i] ) )
    {
      $os_temp = browser_detection ( $last_browser[$i] , $unknown );

      $browser_temp = os_detection ( $last_browser[$i] , $unknown );
    }

 if ( !empty ( $last_hostname [ $i ] ) )
  {
   echo "<tr>";
   echo "<td align='left' width='25'><font size='2'>".($i+1)."</font></td>";
   echo "<td align='left' width='120'><font size='2'>".date($date_format,$last_time [ $i ] )." ".date($time_format,$last_time [ $i ] )."</font></td>";
   echo "<td align='left' width='260'><font size='2'>".$last_hostname [ $i ]."</font></td>";
   echo "<td align='left' width='150'><font size='2'>".$browser_temp."</font></td>";
   echo "<td align='left' width='150'><font size='2'>".$os_temp."</font></td>";
   echo "<td align='left' width='200'><font size='2'>".$last_site [ $i ]."</font></td>";
   echo "<td align='left' width='200'><font size='2'>".$last_referer [ $i ]."</font></td>";
   echo "</tr>";
  }

 }

echo "</table>";


echo "<form method ='get' action ='$PHP_SELF'>
<center>
  <table width='500' border='0'>
    <tr>
      <td align='center' >
         <select name='lastnumber' size='1'>
          <option value='10' selected>10
          <option value='20'>20
          <option value='30'>30
          <option value='40'>40
          <option value='50'>50
          <option value='100'>100
          <option value='250'>250
          <option value='500'>500
          <option value='1000'>1000
          <option value='2000'>2000
          <option value='5000'>5000
         </select>
       <input type = 'submit' value = 'ok'/>
       </td>
   </tr>
  </table>
 </center>
</form>";

}

foreach ( $siteorder as $var1 )
 {
   if ( array_key_exists ( $var1 , $siteorder_array ) )
    $siteorder_array [ $var1 ] = $siteorder_array [ $var1 ] + 1;
   else
    $siteorder_array [ $var1 ] = 1;
 }

 for ( $i = 1 ; $i <= 18 ; $i++ )
  {

     $temp_stat  = "stat".$i;
     $temp_name  = "namestat".$i;
     $temp_sort  = "sort".$i;
     $temp_count = "countstat".$i;


    if ( $$temp_stat == "country" ) statistik_display ( $$temp_name , $domain , $$temp_sort , 150 , $$temp_count );
    if ( $$temp_stat == "provider" ) statistik_display ( $$temp_name , $hostname_kurz , $$temp_sort , 150 , $$temp_count );
    if ( $$temp_stat == "sites" ) statistik_display ( $$temp_name , $site , $$temp_sort , 150 , $$temp_count );
    if ( $$temp_stat == "browser" ) statistik_display ( $$temp_name , $browser , $$temp_sort , 150 , $$temp_count );
    if ( $$temp_stat == "os" ) statistik_display ( $$temp_name , $os , $$temp_sort , 150 , $$temp_count );
    if ( $$temp_stat == "referer" ) statistik_display ( $$temp_name , $referer , $$temp_sort , 150 , $$temp_count );
    if ( $$temp_stat == "month" ) statistik_display ( $$temp_name , $month ,  $$temp_sort , 150 , $$temp_count );
    if ( $$temp_stat == "day" ) statistik_display ( $$temp_name , $day ,  $$temp_sort , 150 , $$temp_count );
    if ( $$temp_stat == "hour" ) statistik_display ( $$temp_name , $hour , $$temp_sort , 150 , $$temp_count );
    if ( $$temp_stat == "weekday" ) statistik_display ( $$temp_name , $weekday , $$temp_sort , 150 , $$temp_count );
    if ( $$temp_stat == "order" ) statistik_display ( $$temp_name , $siteorder_array , $$temp_sort , 250 , $$temp_count );
    if ( $$temp_stat == "year" ) statistik_display ( $$temp_name , $year ,  $$temp_sort , 150 , $$temp_count );
    if ( $$temp_stat == "lastdays" ) statistik_display ( $$temp_name , $daysago ,  $$temp_sort , 150 , $$temp_count );
    if ( $$temp_stat == "referer_lastdays" ) statistik_display ( $$temp_name , $referer_daysago ,  $$temp_sort , 150 , $$temp_count );
    if ( $$temp_stat == "searchwords" ) statistik_display ( $$temp_name , $search_words ,  $$temp_sort , 150 , $$temp_count);
    if ( $$temp_stat == "searchengines" ) statistik_display ( $$temp_name , $search_engines ,  $$temp_sort , 150 , $$temp_count);
    if ( $$temp_stat == "colordepth" ) statistik_display ( $$temp_name , $color_depth ,  $$temp_sort , 150 , $$temp_count);
    if ( $$temp_stat == "resolution" ) statistik_display ( $$temp_name , $resolution ,  $$temp_sort , 150 , $$temp_count);
    
  }

############################################################################################

echo "<br> <br>
<center>
<table width='618' height='10' border='0' cellspacing='0' cellpadding='0' marginwidth='0' marginheight='0'>
<tr>
<td></td>
<td>
 <center>Copyright  2005 by
 <a href='http://www.php-web-statistik.de' target='_blank'>Reimar Hoven</a>. All Rights Reserved.
 <a href='http://www.php-web-statistik.de/haftung.html' target='_blank'>Disclaimer</a>
 </center>
</td>
</tr>
</table></center>
</body></html>";

?>